#
# BEFORE UPDATING THIS PACKAGE, YOU _MUST_ DO THE FOLLOWING:
# - DO A LOCAL BUILD
# - INSTALL IT IN A TEST MACHINE
# - CHECK THAT 'display_help http://google.com' STILL WORK (INCLUDING CLOSING IT)
# - CHECK THAT MCC STILL RUNS
#
%define debug_package %{nil}
# *** ERROR: same build ID in nonidentical files!
#        /usr/bin/jsc-3
#   and  /usr/bin/jsc-1


%define oname		webkitgtk
%define lib3ver		4.0
%define major3		18
%define major2		37
%define devname3	%mklibname webkitgtk %{lib3ver} -d
%define inspector3name	webkit%{lib3ver}-webinspector
%define girname2	%mklibname %{name}2-gir %{lib3ver}
%define girname2extension %mklibname %{name}2webextension-gir %{lib3ver}
%define libwebkit2      %mklibname webkit2gtk %{lib3ver} %{major2}
%define girjscore3	%mklibname jscore-gir %{lib3ver}
%define libjavascriptcoregtk3	%mklibname javascriptcoregtk %{lib3ver} %{major3}

%define pango	0
%if %{pango}
%define fontreq		pkgconfig(pango)
%define fontback	pango
%else
%define fontreq		pkgconfig(fontconfig) >= 1.0.0
%define fontback	freetype
%endif

Summary:	Web browser engine
Name:		webkit
Epoch:		1
Version:	2.8.5
Release:	1
License:	BSD and LGPLv2+
Group:		System/Libraries
Url:		http://www.webkitgtk.org
Source0:	http://www.webkitgtk.org/releases/%{oname}-%{version}.tar.xz
###Patch0:         webkit-2.3.90-link.patch
# (blino) needed for first-time wizard (display_help) to be able to close its window with javascript
###Patch2:         webkit-2.1.90-allowScriptsToCloseWindows.patch
###Patch3:         webkitgtk-2.1.92-gtk-includes.patch

BuildRequires:	bison
BuildRequires:	flex
BuildRequires:	gperf
BuildRequires:	libtool
BuildRequires:	%{fontreq}
BuildRequires:	icu-devel >= 49
BuildRequires:	jpeg-devel
BuildRequires:	libstdc++-devel
BuildRequires:	cmake
BuildRequires:	pkgconfig(enchant)
BuildRequires:	pkgconfig(gail)
BuildRequires:	pkgconfig(gail-3.0)
BuildRequires:	pkgconfig(gl)
BuildRequires:	pkgconfig(geoclue)
BuildRequires:	pkgconfig(gnome-keyring-1)
BuildRequires:	pkgconfig(gobject-introspection-1.0)
BuildRequires:	pkgconfig(gstreamer-plugins-base-1.0)
BuildRequires:	pkgconfig(glib-2.0)
BuildRequires:	pkgconfig(gtk+-2.0)
BuildRequires:	pkgconfig(gtk+-3.0)
BuildRequires:	pkgconfig(libcurl) >= 7.11.0
BuildRequires:	pkgconfig(libpng)
BuildRequires:	pkgconfig(librsvg-2.0) >= 2.2.0
BuildRequires:	pkgconfig(libsecret-1)
BuildRequires:	pkgconfig(libsoup-2.4) >= 2.29.90
BuildRequires:	pkgconfig(libwebp)
BuildRequires:	pkgconfig(libxslt)
BuildRequires:	pkgconfig(ruby)
BuildRequires:	pkgconfig(sqlite3)
BuildRequires:	pkgconfig(xft)
BuildRequires:	pkgconfig(xt)
BuildRequires:	chrpath

%description
WebKit is an open source web browser engine.

#----------------------------------------------------------------------------

%package -n %{name}%{lib3ver}
Summary:	GTK+3 port of WebKit web browser engine - shared files
Group:		Development/GNOME and GTK+
Requires:	%{libwebkit2} = %{EVRD}

%description -n %{name}%{lib3ver}
WebKit is an open source web browser engine.
This package contains the shared files used by %{name}%{lib3ver}

%files -n %{name}%{lib3ver} -f WebKit2GTK-%{lib3ver}.lang

#----------------------------------------------------------------------------

%package -n %{libjavascriptcoregtk3}
Summary:	GTK+3 port of WebKit web browser engine
Group:		System/Libraries

%description -n %{libjavascriptcoregtk3}
The GTK+3 port of WebKit is intended to provide a browser component
primarily for users of the portable GTK+3 UI toolkit on platforms like
Linux.

%files -n %{libjavascriptcoregtk3}
%{_libdir}/libjavascriptcoregtk-%{lib3ver}.so.%{major3}*

#----------------------------------------------------------------------------

%package -n %{devname3}
Summary:	Development files for WebKit GTK+3 port
Group:		Development/GNOME and GTK+
Provides:	webkitgtk4-devel = %{EVRD}
Provides:	libwebkitgtk4-devel = %{EVRD}
Requires:	%{libwebkit2} = %{EVRD}
Requires:	%{libjavascriptcoregtk3} = %{EVRD}
Requires:	%{girjscore3} = %{EVRD}
Requires:	%{girname2} = %{EVRD}
Requires:       %{girname2extension} = %{EVRD}

%description -n %{devname3}
The GTK+ port of WebKit is intended to provide a browser component
primarily for users of the portable GTK+ UI toolkit on platforms like
Linux. This package contains development headers.

%files -n %{devname3}
%{_libdir}/libjavascriptcoregtk-%{lib3ver}.so
%{_libdir}/libwebkit2gtk-%{lib3ver}.so
%{_includedir}/%{name}gtk-%{lib3ver}
%{_libdir}/pkgconfig/javascriptcoregtk-%{lib3ver}.pc
%{_libdir}/pkgconfig/%{name}2gtk-%{lib3ver}.pc
%{_libdir}/pkgconfig/%{name}2gtk-web-extension-%{lib3ver}.pc
%{_datadir}/gir-1.0/JavaScriptCore-%{lib3ver}.gir
%{_datadir}/gir-1.0/WebKit2-%{lib3ver}.gir
%{_datadir}/gir-1.0/WebKit2WebExtension-%{lib3ver}.gir

#----------------------------------------------------------------------------

%package -n webkit4-jsc
Summary:	JavaScriptCore shell for WebKit GTK+3
Group:		Development/GNOME and GTK+

%description -n webkit4-jsc
jsc is a shell for JavaScriptCore, WebKit's JavaScript engine. It
allows you to interact with the JavaScript engine directly.

%files -n webkit4-jsc
%{_bindir}/jsc

#----------------------------------------------------------------------------

%package -n %{girjscore3}
Summary:	GObject Introspection interface description for JSCore
Group:		System/Libraries

%description -n %{girjscore3}
GObject Introspection interface description for JSCore.

%files -n %{girjscore3}
%{_libdir}/girepository-1.0/JavaScriptCore-%{lib3ver}.typelib

#----------------------------------------------------------------------------

%package -n %{girname2}
Summary:        GObject Introspection interface description for %name
Group:          System/Libraries
Requires:       %{libwebkit2} = %{EVRD}

%description -n %{girname2}
GObject Introspection interface description for WebKit2.

%files -n %{girname2}
%{_libdir}/girepository-1.0/WebKit2-%{lib3ver}.typelib

#----------------------------------------------------------------------------

%package -n %{girname2extension}
Summary:        GObject Introspection interface description for %name
Group:          System/Libraries

%description -n %{girname2extension}
GObject Introspection interface description for WebKit2.

%files -n %{girname2extension}
%{_libdir}/girepository-1.0/WebKit2WebExtension-%{lib3ver}.typelib

#----------------------------------------------------------------------------

%package -n %{libwebkit2}
Summary:        GTK+3 port of WebKit2 web browser engine
Group:          System/Libraries
Requires:       %{name}%{lib3ver} = %{EVRD}
Requires:       %{name}2gtk%{lib3ver} = %{EVRD}
Provides:       libwebkit2gtk3 = %{version}-%{release}

%description -n %{libwebkit2}
The GTK+3 port of WebKit2 is intended to provide a browser component
primarily for users of the portable GTK+3 UI toolkit on platforms like
Linux.

%files -n %{libwebkit2}
%{_libdir}/lib%{name}2gtk-%{lib3ver}.so.%{major2}
%{_libdir}/lib%{name}2gtk-%{lib3ver}.so.%{major2}.*

#----------------------------------------------------------------------------

%package -n %{name}2gtk%{lib3ver}
Summary:        GTK+3 port of WebKit2 web browser engine - shared files
Group:          System/Libraries

%description -n %{name}2gtk%{lib3ver}
WebKit is an open source web browser engine.
This package contains the shared files used by %{name}2gtk%{lib3ver}.

%files -n %{name}2gtk%{lib3ver}
%dir %{_libdir}/webkit2gtk-%{lib3ver}
%dir %{_libdir}/webkit2gtk-%{lib3ver}/injected-bundle
%{_libdir}/webkit2gtk-%{lib3ver}/injected-bundle/libwebkit2gtkinjectedbundle.so
%{_libexecdir}/webkit2gtk-%{lib3ver}/WebKitNetworkProcess
%{_libexecdir}/webkit2gtk-%{lib3ver}/WebKitPluginProcess*
%{_libexecdir}/webkit2gtk-%{lib3ver}/WebKitWebProcess

#----------------------------------------------------------------------------

%prep
%setup -qn %{oname}-%{version}
%apply_patches

%build
# Use linker flags to reduce memory consumption on low-mem architectures
%ifarch %{arm}
%define lowmemflags -Wl,--no-keep-memory -Wl,--reduce-memory-overheads
export CFLAGS="`echo %{optflags} %lowmemflags | sed -e 's/-gdwarf-4//' -e 's/-fvar-tracking-assignments//' -e 's/-frecord-gcc-switches//'`"
mkdir -p bfd
ln -s %{_bindir}/ld.bfd bfd/ld
export PATH=$PWD/bfd:$PATH
export CC="%{__cc} -fuse-ld=bfd"
export CXX="%{__cxx} -fuse-ld=bfd"
%global ldflags %{ldflags} -fuse-ld=bfd
%else
export CFLAGS="`echo %{optflags} | sed -e 's/-gdwarf-4//' -e 's/-fvar-tracking-assignments//' -e 's/-frecord-gcc-switches//'`"
%endif

export CXXFLAGS="$CFLAGS"

%cmake \
  -DLIBEXEC_INSTALL_DIR=%{_libdir}/webkit2gtk-%{lib3ver} \
  -DPORT=GTK \
  -DCMAKE_BUILD_TYPE=Release \
  -DENABLE_GTKDOC=OFF

# https://bugs.gentoo.org/show_bug.cgi?id=515968
make V=1 -j1

%install
%makeinstall_std -C build

# only useful for testing, should not be installed system-wide.
# reported upstream as 22812 - AdamW 2008/12
rm -rf %{buildroot}%{_libdir}/libtestnetscapeplugin.*

# Remove lib64 rpaths
chrpath --delete %{buildroot}%{_bindir}/jsc

%find_lang WebKit2GTK-%{lib3ver}


%changelog

* Wed Sep 16 2015 Tigro <ashejn@yandex-team.ru> 1:2.8.5-1
- (1e169f1) update to 2.8.5

* Tue Jun 09 2015 Tigro <ashejn@gmail.com> 1:2.8.3-1
- (1f66e01) update to 2.8.3

* Tue Mar 24 2015 Tigro <ashejn@gmail.com> 1:2.8.0-1
- (79564bf) update to 2.8.0

* Fri Mar 13 2015 Tigro <ashejn@gmail.com> 1:2.7.91-2
- (a5f1444) fix requires

* Thu Mar 12 2015 Tigro <ashejn@gmail.com> 1:2.7.91-1
- (0572a59) added api version to webkit2gtk package name to avoid conflict with old webkit2gtk
- (Tigro: 67f132d) fix depends again
- (Tigro: 4a24899) fix requires and clean up spec
- (Tigro: 2c32feb) rename spec file

* Wed Mar 11 2015 Tigro <ashejn@gmail.com> None
- (15174a5) fix libexecdir again
- (Tigro: 441ef34) define libexecdir
- (Tigro: f32360b) webkit.spec
- (Tigro: f32360b) clean up spec
- (Tigro: d476d44) disable gtk-doc really
- (Tigro: 61449fe) build without gtk-doc
- (Tigro: 500372f) fix typo
- (Tigro: c2e12d8) fixed some lib version
- (Tigro: da5cb94) fix typo
- (Tigro: e36ccce) fix typo
- (Tigro: 271de87) another cmake call
- (Tigro: 54bcca4) cmake instead of autotools
- (Tigro: bd54a91) update to 2.7.91
- (Alexander Lakhin: 85b183c) MassBuild#656: Increase release tag
- (Andrey Bondrov: 68461c9) Build with less parallel jobs, add ruby to BuildRequires
- (Tigro: 9cf77cc) update to 2.4.5
- (Alex Burmashev: 9b58f5a) MassBuild#440: Increase release tag
- (Andrey Bondrov: 2ad9317) Bump release to rebuild against new icu
- (Andrey Bondrov: 1b8ca39) MassBuild#430: Increase release tag
- (Tigro: 337e6eb) update to 2.4.3
- (Tigro: 59e6ba4) pack some files
- (Tigro: ab23728) added BR: automake
- (Tigro: 4504190) fix name


